#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <termios.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <msnmp.h>
#include "disco.h"

int get_snmp_writecom(char *buff, int len) {
  struct termios tsave, t;
  FILE *file;
  char *ptr;
  int c;

  file=fopen(ctermid(NULL), "r+");
  if (!file) {
    perror("opening terminal");
    return(-1);
  }
  setbuf(file, NULL);

  tcgetattr(fileno(file), &tsave);

  memcpy(&t, &tsave, sizeof(tsave));
  t.c_lflag &= ~(ECHO|ECHOE|ECHOK|ECHONL);
  tcsetattr(fileno(file), TCSAFLUSH, &t);
  fputs("Write community: ", file);

  ptr=buff;
  while((c=getc(file)) != EOF && c!= '\n') {
    if (ptr<&buff[len]) {
      *ptr++=c;
    }
  }

  *ptr=0;
  putc('\n', file);
  
  tcsetattr(fileno(file), TCSAFLUSH, &tsave);

  fclose(file);
  return(0);
}


int snmp_get_config(char *hostname, char *writecom) {
  int ret;
  char obj[1024], resp[1024], localhost[1024];
  struct hostent *h;
  struct sockaddr_in addr;

  ret=gethostname(localhost, 256);
  if (ret) {
    perror("getting local hostname");
    return(-1);
  }

  h=gethostbyname(localhost);
  if (!h) {
    printf("Could not resolve hostname %s\n", hostname);
    return(-1);
  }
  memset(&addr, 0, sizeof(struct sockaddr_in));
  addr.sin_family=AF_INET;
  memcpy(&addr.sin_addr, h->h_addr, sizeof(struct in_addr));

  sprintf(obj, ".1.3.6.1.4.1.9.2.1.55.%s", inet_ntoa(addr.sin_addr));
  if (verbose) printf("Sending request for %s\n", obj);
  
  /* send the request, but don't hang out waiting for a response (zero timeout) */
  ret=msnmp_set(hostname, writecom, obj, "string", "/config", resp, 0, 1);
  if (ret) {
    printf("SNMP command was no successful.\n");
    return(-1);
  }

  return(0);
}



